--- a/etc/init.d/dsm_sa_ipmi	2009-10-19 04:10:19.000000000 -0500
+++ b/etc/init.d/dsm_sa_ipmi	2013-03-19 19:48:22.724097187 -0500
@@ -183,9 +183,17 @@
 load_si()
 {
 	if [ "${IPMI_SI}" = "yes" ]; then
+		echo "loading ipmi_si"
 		modprobe ${IPMI_SI_MODULE_NAME} > /dev/null 2>&1
+		probefail=$?
 		modules_loaded ${IPMI_SI_MODULE_NAME}
-		[ ${OnePlusLoaded} -ne 1 ] && RETVAL=$((RETVAL | 1))
+		if [ ${probefail} -ne 0 ]; then
+			modprobe platform:ipmi_si > /dev/null 2>&1
+			[ $? -ne 0 ] && RETVAL=$((RETVAL | 1))
+			echo "attempted using in-tree ipmi_si driver, loading ipmi_devintf"
+		else
+			[ ${OnePlusLoaded} -ne 1 ] && RETVAL=$((RETVAL | 1))
+		fi
 	fi
 }
 
@@ -362,9 +370,13 @@
 load_ipmi_modules ()
 {
 	local locdelay
-	modprobe ipmi_msghandler > /dev/null 2>&1
-	modules_loaded ipmi_msghandler
-	[ ${OnePlusLoaded} -ne 1 ] && unload_all_ipmi_modules && RETVAL=$((RETVAL | 1)) && return
+	if [ -d /proc/ipmi ]; then
+		echo "ipmi_msghandler already loaded or in-kernel"
+	else
+		modprobe ipmi_msghandler > /dev/null 2>&1
+		modules_loaded ipmi_msghandler
+		[ ${OnePlusLoaded} -ne 1 ] && unload_all_ipmi_modules && RETVAL=$((RETVAL | 1)) && return
+	fi
 	load_hw_modules
 	[ $((RETVAL & 1)) -eq 1 ] && unload_all_ipmi_modules && RETVAL=$((RETVAL | 1)) && return
 
